var backWidth = 220;
var backHeight = 290;
var frontWidth = 220;
var frontHeight = 190;
var backshown = false;

function setup() {
  if (window.widget) {
    widgetSetup();
    widget.onshow = onshow;
    widget.onremove = clearPrefs;
    readPrefs();
    if (widget.context != null) {
      var link = document.getElementById("Widgetop");
      if (link != null) {
        link.style.display = "none";
      }
    }
  }  
}

function readPrefs() {
  var value = widget.preferenceForKey(widget.identifier + "-keys");
  if (value) {
    document.getElementById("Keys").value = value;
  }
  value = widget.preferenceForKey(widget.identifier + "-color");
  if (value) {
    document.getElementById("Color").value = value;
  }
  value = widget.preferenceForKey(widget.identifier + "-type");
  if (value) {
    document.getElementById("Type").value = value;
  }
  window.resizeTo(frontWidth, frontHeight); 
  reload();   
}

function clearPrefs() {
   widget.setPreferenceForKey(null, widget.identifier + "-keys");   
   widget.setPreferenceForKey(null, widget.identifier + "-color");   
   widget.setPreferenceForKey(null, widget.identifier + "-type");     
}

function onshow() {
  window.resizeTo(frontWidth, frontHeight); 
}

function reload() {
  var keys = document.getElementById("Keys").value;
  var link = '<style type="text/css">' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 td {margin:0 !important;padding:0 !important;border:0 !important;}' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/de/header/radio/regular_black.png) no-repeat 0 0 !important;}' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 tr.lfmEmbed object {float:left;}' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/black_np.png) no-repeat 0px 0 !important;;}' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/black_np.png) no-repeat -85px 0 !important;}' +
      'table.lfmWidget2a5a1fd104adc9059fe615f89b7e49e0 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/de/footer/black_np.png) no-repeat -159px 0 !important;}' +
      '</style>' +
      '<table class="lfmWidget2a5a1fd104adc9059fe615f89b7e49e0" cellpadding="0" cellspacing="0" border="0" style="width:184px;">' +
      '<tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/radio/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="184" height="140" >' +
      '<param name="movie" value="http://cdn.last.fm/widgets/radio/19.swf" /> ' +
      '<param name="flashvars" value="lfmMode=radio&amp;radioURL=';
      if (document.getElementById("Type").value == "artist") {
        link += 'artist%2F' + encodeURIComponent(keys) +
            '%2Fsimilarartists';
      }
      else {
        link += 'globaltags%2F' + encodeURIComponent(keys);
      }
      link +='&amp;title=' +
          'Similar+Music+to+' + encodeURIComponent(keys) +
          '&amp;theme=' + document.getElementById("Color").value +
      '&amp;autostart=&amp;lang=en&amp;widget_id=2a5a1fd104adc9059fe615f89b7e49e0" /> ' +
      '<param name="bgcolor" value="000000" /> ' +
      '<param name="quality" value="high" /> ' +
      '<param name="allowScriptAccess" value="always" /> ' +
      '<param name="allowNetworking" value="all" /> ' +
      '</object></td></tr>' +
      '<tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/black.png) repeat-x 0 0;text-align:right;">' +
      '</td></tr>' +
      '</table>';
   document.getElementById("Main").innerHTML = link;
   widget.setPreferenceForKey(keys, widget.identifier + "-keys");   
   widget.setPreferenceForKey(document.getElementById("Color").value, widget.identifier + "-color");   
   widget.setPreferenceForKey(document.getElementById("Type").value, widget.identifier + "-type");   
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "black", showBack);
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    backShown = true;
    front.style.display="none";
    window.resizeTo(backWidth, backHeight);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    backShown = false;
    back.style.display="none";
    window.resizeTo(frontWidth, frontHeight);  
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
    reload();    
}                                                
  